VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "xTimer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Diesen Teil in ein neu angelegtes Klassenmodul kopieren
'und den Namen "xTimer" zuweisen

Option Explicit

Private Type LARGE_INTEGER
    lowpart As Long
    highpart As Long
End Type

Dim strt As LARGE_INTEGER
Dim Ende As LARGE_INTEGER
Dim freq As LARGE_INTEGER
Dim calibr As Double

Private Declare Function QueryPerformanceCounter _
                    Lib "kernel32" (lpPerformanceCount _
                    As LARGE_INTEGER) As Long
                    
Private Declare Function QueryPerformanceFrequency _
                    Lib "kernel32" (lpFrequency _
                    As LARGE_INTEGER) As Long

Private Sub Class_Initialize()
    QueryPerformanceFrequency freq
End Sub

Public Sub Calibrieren()
    QueryPerformanceCounter strt
    QueryPerformanceCounter Ende
    calibr = (d(Ende) - d(strt)) / d(freq) * 1000 'ms
End Sub

Public Sub Start()
    QueryPerformanceCounter strt
End Sub

Public Sub Halt()
    QueryPerformanceCounter Ende
End Sub

Public Property Get RunTime() As Variant  'ms
    RunTime = (d(Ende) - d(strt)) / d(freq) * 1000 - calibr
      If RunTime < 0 Then RunTime = 0
End Property

Private Function d(x As LARGE_INTEGER) As Double
    d = x.lowpart + x.highpart * 4294967296#
End Function
